//----------------------------------------------------------------
//                    AsynMdi.DLL
//  This DLL provide an interface between windows clients and the
//  AsynSrv utility.
//----------------------------------------------------------------


#include <windows.h>
#include <string.h>

LPSTR  lpMessageBlock[10];
HANDLE hMessageBlock[10];

char alloc_flag[10] = "NNNNNNNNNN";


/*  *** Function Prototypes *** */

void CommonLogic (int, LPSTR);
void FAR PASCAL AsynSrv0(LPSTR);
void FAR PASCAL AsynSrv1(LPSTR);
void FAR PASCAL AsynSrv2(LPSTR);
void FAR PASCAL AsynSrv3(LPSTR);
void FAR PASCAL AsynSrv4(LPSTR);
void FAR PASCAL AsynSrv5(LPSTR);
void FAR PASCAL AsynSrv6(LPSTR);
void FAR PASCAL AsynSrv7(LPSTR);
void FAR PASCAL AsynSrv8(LPSTR);
void FAR PASCAL AsynSrv9(LPSTR);



// ** DLL library entry point

int FAR PASCAL LibMain (HANDLE hInstance, WORD wDataSeg,
                        WORD wHeapSize, LPSTR lpszCmdLine )
{
  if (wHeapSize > 0)
     UnlockData (0);
  return (1);
}

//-------------------------------------------------------------------
// Entry points to call corresponding instances of the AsynSrv utility
//-------------------------------------------------------------------
void FAR PASCAL AsynSrv0 (LPSTR ptr_value)
{
 CommonLogic(0, ptr_value);
}

void FAR PASCAL AsynSrv1 (LPSTR ptr_value)
{
 CommonLogic(1, ptr_value);
}

void FAR PASCAL AsynSrv2 (LPSTR ptr_value)
{
 CommonLogic(2, ptr_value);
}

void FAR PASCAL AsynSrv3 (LPSTR ptr_value)
{
 CommonLogic(3, ptr_value);
}

void FAR PASCAL AsynSrv4 (LPSTR ptr_value)
{
 CommonLogic(4, ptr_value);
}

void FAR PASCAL AsynSrv5 (LPSTR ptr_value)
{
 CommonLogic(5, ptr_value);
}

void FAR PASCAL AsynSrv6 (LPSTR ptr_value)
{
 CommonLogic(6, ptr_value);
}

void FAR PASCAL AsynSrv7 (LPSTR ptr_value)
{
 CommonLogic(7, ptr_value);
}

void FAR PASCAL AsynSrv8 (LPSTR ptr_value)
{
 CommonLogic(8, ptr_value);
}

void FAR PASCAL AsynSrv9 (LPSTR ptr_value)
{
 CommonLogic(9, ptr_value);
}



void CommonLogic (int i, LPSTR ptr_value)
{
 if (alloc_flag[i] == 'N')
  {
   alloc_flag[i] = 'Y';

   //    *** Allocate a shared buffer from the Global heap ***
   hMessageBlock[i] = GlobalAlloc (GMEM_SHARE, 1000);
   if (hMessageBlock[i] == 0)
     {
       MessageBox (GetActiveWindow(),
           "Allocation of shared memory block failed", "ERROR",
                                                      MB_OK);
       PostQuitMessage(0);
       return;
     }
  }

  lpMessageBlock[i] = GlobalLock (hMessageBlock[i]);

  // *** Move client request into the shared memory ***
  _fstrcpy (lpMessageBlock[i], ptr_value);

  SendMessage (0xFFFF, WM_USER, 990 + i, (long) lpMessageBlock[i]);

  GlobalUnlock (hMessageBlock[i]);
 }
